#version 430

out vec4 color;
  
in vec2 outUVs;

uniform sampler2D scene;
uniform sampler2D bloomBlur;
uniform sampler2D volumetricLight;
uniform float exposure;

void main()
{             
    const float gamma = 2.2;     
    vec3 bloomColor = texture(bloomBlur, outUVs).rgb;
    vec3 volumetricColor = texture(volumetricLight, outUVs).rgb;
    bloomColor = pow(bloomColor, vec3(gamma));
    volumetricColor = pow(volumetricColor, vec3(gamma));

    volumetricColor += bloomColor;
    // tone mapping
    vec3 result = vec3(1.0) - exp(-volumetricColor * exposure);      
    result = pow(result, vec3(1.0 / gamma));
    color = vec4(result, 1.0);
}
