#version 430

uniform sampler2D albedoMap;
uniform sampler2D densityMap; // greyscale map
uniform float brightness;

in VertexData_GS_FS {
    vec3 normalWorld;
    vec2 uvs;
    flat float normalizedDistance;
} vert;

layout(location = 0) out vec4 color;

void main () {
    float furStrength = 1.0 - vert.normalizedDistance;
    vec4 albedo = texture(albedoMap, vert.uvs);
    vec4 density = texture(densityMap, vert.uvs);

    vec3 furColor = albedo.rgb * (vert.normalizedDistance * 0.5 + 0.5);
    float alpha = density.r * (-pow(vert.normalizedDistance, 5.0) + 1);
    
    color = vec4(furColor + brightness, alpha);
}
