#version 430

in CornerData {
	vec2 topLeft;
    vec2 topRight;
    vec2 bottomLeft;
    vec2 bottomRight;
} corner;

uniform sampler2D depthTex;

void main()
{
    float depthTexTopLeft = texture(depthTex, corner.topLeft).x;
	float depthTexTopRight = texture(depthTex, corner.topRight).x;
	float depthTexBottomLeft = texture(depthTex, corner.bottomLeft).x;
	float depthTexBottomRight = texture(depthTex, corner.bottomRight).x;

	float minDepth = min(min(depthTexTopLeft, depthTexTopRight), min(depthTexBottomLeft, depthTexBottomRight));
	float maxDepth = max(max(depthTexTopLeft, depthTexTopRight), max(depthTexBottomLeft, depthTexBottomRight));
	vec2 position = mod(gl_FragCoord.xy, 2);
	int index = int(position.x + position.y);
	gl_FragDepth = index == 1 ? minDepth : maxDepth;
}