#version 430

layout (location = 0) in vec3 position;
layout (location = 2) in vec2 uvs;

uniform sampler2D depthTex;

out CornerData {
	vec2 topLeft;
    vec2 topRight;
    vec2 bottomLeft;
    vec2 bottomRight;
} corner;

void main()
{
    vec2 texelSize = 1.0 / textureSize(depthTex, 0);

    corner.topLeft = uvs - 0.5 * texelSize;
    corner.topRight = corner.topLeft + vec2(texelSize.x, 0);
	corner.bottomLeft = corner.topLeft + vec2(0, texelSize.y);
	corner.bottomRight = corner.topLeft + texelSize;

    gl_Position = vec4(position, 1.0);
}